﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	color1 : vec3<f32>,
	color2 : vec3<f32>,
	color3 : vec3<f32>,
	color4 : vec3<f32>,
	ditherIntensity : f32,
	intensity : f32	
};

%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

fn find_closest(reff: vec3<f32>) -> vec3<f32> {
	var old: vec3<f32> = vec3<f32>(100. * 255.);
	old = mix (shaderParams.color1 * 255., old, step (length (old - reff), length (shaderParams.color1 * 255. - reff)));
	old = mix (shaderParams.color2 * 255., old, step (length (old - reff), length (shaderParams.color2 * 255. - reff)));
	old = mix (shaderParams.color3 * 255., old, step (length (old - reff), length (shaderParams.color3 * 255. - reff)));
	old = mix (shaderParams.color4 * 255., old, step (length (old - reff), length (shaderParams.color4 * 255. - reff)));
	return old;
} 

fn dither_matrix(x: f32, y: f32) -> f32 {
	return mix(mix(mix(mix(mix(mix(0., 32., step(1., y)), mix(8., 40., step(3., y)), step(2., y)), mix(mix(2., 34., step(5., y)), mix(10., 42., step(7., y)), step(6., y)), step(4., y)), mix(mix(mix(48., 16., step(1., y)), mix(56., 24., step(3., y)), step(2., y)), mix(mix(50., 18., step(5., y)), mix(58., 26., step(7., y)), step(6., y)), step(4., y)), step(1., x)), mix(mix(mix(mix(12., 44., step(1., y)), mix(4., 36., step(3., y)), step(2., y)), mix(mix(14., 46., step(5., y)), mix(6., 38., step(7., y)), step(6., y)), step(4., y)), mix(mix(mix(60., 28., step(1., y)), mix(52., 20., step(3., y)), step(2., y)), mix(mix(62., 30., step(5., y)), mix(54., 22., step(7., y)), step(6., y)), step(4., y)), step(3., x)), step(2., x)), mix(mix(mix(mix(mix(3., 35., step(1., y)), mix(11., 43., step(3., y)), step(2., y)), mix(mix(1., 33., step(5., y)), mix(9., 41., step(7., y)), step(6., y)), step(4., y)), mix(mix(mix(51., 19., step(1., y)), mix(59., 27., step(3., y)), step(2., y)), mix(mix(49., 17., step(5., y)), mix(57., 25., step(7., y)), step(6., y)), step(4., y)), step(5., x)), mix(mix(mix(mix(15., 47., step(1., y)), mix(7., 39., step(3., y)), step(2., y)), mix(mix(13., 45., step(5., y)), mix(5., 37., step(7., y)), step(6., y)), step(4., y)), mix(mix(mix(63., 31., step(1., y)), mix(55., 23., step(3., y)), step(2., y)), mix(mix(61., 29., step(5., y)), mix(53., 21., step(7., y)), step(6., y)), step(4., y)), step(7., x)), step(6., x)), step(4., x));
} 

fn dither(color: vec3<f32>, uv: vec2<f32>) -> vec3<f32> {
	var colorr : vec3<f32> = color * 255.;
	colorr += dither_matrix(((uv.x) % (8.)), ((uv.y) % (8.))) * shaderParams.ditherIntensity;
	colorr = find_closest(clamp(colorr, vec3<f32>(0.), vec3<f32>(255.)));
	return colorr / 255.;
} 

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	var front : vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);

	var output : FragmentOutput;
	output.color = mix(front, vec4<f32>(dither(front.rgb, input.fragPos.xy), front.a), shaderParams.intensity);
	return output;
}